<html>
<head>
<title>OgreBillboard.h Source File - OGRE Documentation</title> <meta http-equiv="Content-Type" content="text/html; charset=iso-8859-1"> 
<link type="text/css" rel="stylesheet" href="doxygen.css">
<link type="text/css" rel="stylesheet" href="tabs.css">
</head>

<body>
<!-- Generated by Doxygen 1.7.6.1 -->
  <div id="navrow1" class="tabs">
    <ul class="tablist">
      <li><a href="index.html"><span>Main&#160;Page</span></a></li>
      <li><a href="pages.html"><span>Related&#160;Pages</span></a></li>
      <li><a href="modules.html"><span>Modules</span></a></li>
      <li><a href="namespaces.html"><span>Namespaces</span></a></li>
      <li><a href="annotated.html"><span>Classes</span></a></li>
      <li class="current"><a href="files.html"><span>Files</span></a></li>
      <li><a href="dirs.html"><span>Directories</span></a></li>
    </ul>
  </div>
  <div id="navrow2" class="tabs2">
    <ul class="tablist">
      <li><a href="files.html"><span>File&#160;List</span></a></li>
      <li><a href="globals.html"><span>File&#160;Members</span></a></li>
    </ul>
  </div>
  <div id="nav-path" class="navpath">
    <ul>
      <li class="navelem"><a class="el" href="dir_aff4b7fb8d70b825eb8a2d7b3cbd2684.html">OgreMain</a>      </li>
      <li class="navelem"><a class="el" href="dir_5049b8c488e02232e72cb8867fab4a28.html">include</a>      </li>
    </ul>
  </div>
</div>
<div class="header">
  <div class="headertitle">
<div class="title">OgreBillboard.h</div>  </div>
</div><!--header-->
<div class="contents">
<a href="OgreBillboard_8h.html">Go to the documentation of this file.</a><div class="fragment"><pre class="fragment"><a name="l00001"></a>00001 <span class="comment">/*</span>
<a name="l00002"></a>00002 <span class="comment">-----------------------------------------------------------------------------</span>
<a name="l00003"></a>00003 <span class="comment">This source file is part of OGRE</span>
<a name="l00004"></a>00004 <span class="comment">    (Object-oriented Graphics Rendering Engine)</span>
<a name="l00005"></a>00005 <span class="comment">For the latest info, see http://www.ogre3d.org/</span>
<a name="l00006"></a>00006 <span class="comment"></span>
<a name="l00007"></a>00007 <span class="comment">Copyright (c) 2000-2012 Torus Knot Software Ltd</span>
<a name="l00008"></a>00008 <span class="comment"></span>
<a name="l00009"></a>00009 <span class="comment">Permission is hereby granted, free of charge, to any person obtaining a copy</span>
<a name="l00010"></a>00010 <span class="comment">of this software and associated documentation files (the &quot;Software&quot;), to deal</span>
<a name="l00011"></a>00011 <span class="comment">in the Software without restriction, including without limitation the rights</span>
<a name="l00012"></a>00012 <span class="comment">to use, copy, modify, merge, publish, distribute, sublicense, and/or sell</span>
<a name="l00013"></a>00013 <span class="comment">copies of the Software, and to permit persons to whom the Software is</span>
<a name="l00014"></a>00014 <span class="comment">furnished to do so, subject to the following conditions:</span>
<a name="l00015"></a>00015 <span class="comment"></span>
<a name="l00016"></a>00016 <span class="comment">The above copyright notice and this permission notice shall be included in</span>
<a name="l00017"></a>00017 <span class="comment">all copies or substantial portions of the Software.</span>
<a name="l00018"></a>00018 <span class="comment"></span>
<a name="l00019"></a>00019 <span class="comment">THE SOFTWARE IS PROVIDED &quot;AS IS&quot;, WITHOUT WARRANTY OF ANY KIND, EXPRESS OR</span>
<a name="l00020"></a>00020 <span class="comment">IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,</span>
<a name="l00021"></a>00021 <span class="comment">FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE</span>
<a name="l00022"></a>00022 <span class="comment">AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER</span>
<a name="l00023"></a>00023 <span class="comment">LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,</span>
<a name="l00024"></a>00024 <span class="comment">OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN</span>
<a name="l00025"></a>00025 <span class="comment">THE SOFTWARE.</span>
<a name="l00026"></a>00026 <span class="comment">-----------------------------------------------------------------------------</span>
<a name="l00027"></a>00027 <span class="comment">*/</span>
<a name="l00028"></a>00028 
<a name="l00029"></a>00029 <span class="preprocessor">#ifndef __Billboard_H__</span>
<a name="l00030"></a>00030 <span class="preprocessor"></span><span class="preprocessor">#define __Billboard_H__</span>
<a name="l00031"></a>00031 <span class="preprocessor"></span>
<a name="l00032"></a>00032 <span class="preprocessor">#include &quot;<a class="code" href="OgrePrerequisites_8h.html">OgrePrerequisites.h</a>&quot;</span>
<a name="l00033"></a>00033 
<a name="l00034"></a>00034 <span class="preprocessor">#include &quot;<a class="code" href="OgreVector3_8h.html">OgreVector3.h</a>&quot;</span>
<a name="l00035"></a>00035 <span class="preprocessor">#include &quot;<a class="code" href="OgreColourValue_8h.html">OgreColourValue.h</a>&quot;</span>
<a name="l00036"></a>00036 <span class="preprocessor">#include &quot;<a class="code" href="OgreCommon_8h.html">OgreCommon.h</a>&quot;</span>
<a name="l00037"></a>00037 
<a name="l00038"></a>00038 <span class="keyword">namespace </span>Ogre {
<a name="l00066"></a><a class="code" href="classOgre_1_1Billboard.html">00066</a>     <span class="keyword">class </span><a class="code" href="OgrePlatform_8h.html#a20566b1253bae200372ed9162489a663">_OgreExport</a> <a class="code" href="classOgre_1_1Billboard.html" title="A billboard is a primitive which always faces the camera in every frame.">Billboard</a> : <span class="keyword">public</span> <a class="code" href="classOgre_1_1AllocatedObject.html" title="Superclass for all objects that wish to use custom memory allocators when their new / delete operator...">FXAlloc</a>
<a name="l00067"></a>00067     {
<a name="l00068"></a><a class="code" href="classOgre_1_1Billboard.html#a7f055c0ed81c6b3bef6d154d128093a1">00068</a>         <span class="keyword">friend</span> <span class="keyword">class </span><a class="code" href="classOgre_1_1BillboardSet.html" title="A collection of billboards (faces which are always facing the given direction) with the same (default...">BillboardSet</a>;
<a name="l00069"></a><a class="code" href="classOgre_1_1Billboard.html#a261647d2b3ed936e9a2f05309ae878d0">00069</a>         <span class="keyword">friend</span> <span class="keyword">class </span><a class="code" href="classOgre_1_1BillboardParticleRenderer.html" title="Specialisation of ParticleSystemRenderer to render particles using a BillboardSet.">BillboardParticleRenderer</a>;
<a name="l00070"></a>00070     <span class="keyword">protected</span>:
<a name="l00071"></a><a class="code" href="classOgre_1_1Billboard.html#afb34875469363c35f235c8746d8664f2">00071</a>         <span class="keywordtype">bool</span> <a class="code" href="classOgre_1_1Billboard.html#afb34875469363c35f235c8746d8664f2">mOwnDimensions</a>;
<a name="l00072"></a><a class="code" href="classOgre_1_1Billboard.html#a45a151660ff2ea011a7c051f50d18ef3">00072</a>         <span class="keywordtype">bool</span> <a class="code" href="classOgre_1_1Billboard.html#a45a151660ff2ea011a7c051f50d18ef3">mUseTexcoordRect</a>;
<a name="l00073"></a><a class="code" href="classOgre_1_1Billboard.html#a3d416b1519dc19dde0550cf8ac92d1e1">00073</a>         <a class="code" href="namespaceOgre.html#aa8263b218e7d187ad5ef03a73a6ad7fd">uint16</a> <a class="code" href="classOgre_1_1Billboard.html#a3d416b1519dc19dde0550cf8ac92d1e1">mTexcoordIndex</a>;      <span class="comment">// index into the BillboardSet array of texture coordinates</span>
<a name="l00074"></a><a class="code" href="classOgre_1_1Billboard.html#a8100e3deb204c1c8d5f2dd4429cad6b2">00074</a>         <a class="code" href="structOgre_1_1TRect.html">FloatRect</a> <a class="code" href="classOgre_1_1Billboard.html#a8100e3deb204c1c8d5f2dd4429cad6b2">mTexcoordRect</a>;    <span class="comment">// individual texture coordinates</span>
<a name="l00075"></a><a class="code" href="classOgre_1_1Billboard.html#aa025549188dc792b76507cf2c7f02c9f">00075</a>         <a class="code" href="namespaceOgre.html#aa3a7b6dfb905e6572d62f0dfa3d4274d" title="Software floating point type.">Real</a> <a class="code" href="classOgre_1_1Billboard.html#aa025549188dc792b76507cf2c7f02c9f">mWidth</a>;
<a name="l00076"></a><a class="code" href="classOgre_1_1Billboard.html#a19e9a04c451b91b5c74d61b7040c9adb">00076</a>         <a class="code" href="namespaceOgre.html#aa3a7b6dfb905e6572d62f0dfa3d4274d" title="Software floating point type.">Real</a> <a class="code" href="classOgre_1_1Billboard.html#a19e9a04c451b91b5c74d61b7040c9adb">mHeight</a>;
<a name="l00077"></a>00077     <span class="keyword">public</span>:
<a name="l00078"></a>00078         <span class="comment">// Note the intentional public access to main internal variables used at runtime</span>
<a name="l00079"></a>00079         <span class="comment">// Forcing access via get/set would be too costly for 000&#39;s of billboards</span>
<a name="l00080"></a><a class="code" href="classOgre_1_1Billboard.html#aa7ad6c8789d8589787c4da34c670d66c">00080</a>         <a class="code" href="classOgre_1_1Vector3.html" title="Standard 3-dimensional vector.">Vector3</a> <a class="code" href="classOgre_1_1Billboard.html#aa7ad6c8789d8589787c4da34c670d66c">mPosition</a>;
<a name="l00081"></a>00081         <span class="comment">// Normalised direction vector</span>
<a name="l00082"></a><a class="code" href="classOgre_1_1Billboard.html#a64425b354973d2d957bc878fca407aad">00082</a>         <a class="code" href="classOgre_1_1Vector3.html" title="Standard 3-dimensional vector.">Vector3</a> <a class="code" href="classOgre_1_1Billboard.html#a64425b354973d2d957bc878fca407aad">mDirection</a>;
<a name="l00083"></a><a class="code" href="classOgre_1_1Billboard.html#aaa2fce61abce942e356fd81925c394fd">00083</a>         <a class="code" href="classOgre_1_1BillboardSet.html" title="A collection of billboards (faces which are always facing the given direction) with the same (default...">BillboardSet</a>* <a class="code" href="classOgre_1_1Billboard.html#aaa2fce61abce942e356fd81925c394fd">mParentSet</a>;
<a name="l00084"></a><a class="code" href="classOgre_1_1Billboard.html#aef9f7ad996732865cd2c8842ee265064">00084</a>         <a class="code" href="classOgre_1_1ColourValue.html" title="Class representing colour.">ColourValue</a> <a class="code" href="classOgre_1_1Billboard.html#aef9f7ad996732865cd2c8842ee265064">mColour</a>;
<a name="l00085"></a><a class="code" href="classOgre_1_1Billboard.html#ad861053413ca65e059dd74131a084839">00085</a>         <a class="code" href="classOgre_1_1Radian.html" title="Wrapper class which indicates a given angle value is in Radians.">Radian</a> <a class="code" href="classOgre_1_1Billboard.html#ad861053413ca65e059dd74131a084839">mRotation</a>;
<a name="l00086"></a>00086 
<a name="l00089"></a>00089         <a class="code" href="classOgre_1_1Billboard.html" title="A billboard is a primitive which always faces the camera in every frame.">Billboard</a>();
<a name="l00090"></a>00090 
<a name="l00093"></a>00093         ~<a class="code" href="classOgre_1_1Billboard.html" title="A billboard is a primitive which always faces the camera in every frame.">Billboard</a>();
<a name="l00094"></a>00094 
<a name="l00097"></a>00097         <a class="code" href="classOgre_1_1Billboard.html" title="A billboard is a primitive which always faces the camera in every frame.">Billboard</a>(<span class="keyword">const</span> <a class="code" href="classOgre_1_1Vector3.html" title="Standard 3-dimensional vector.">Vector3</a>&amp; position, <a class="code" href="classOgre_1_1BillboardSet.html" title="A collection of billboards (faces which are always facing the given direction) with the same (default...">BillboardSet</a>* owner, <span class="keyword">const</span> <a class="code" href="classOgre_1_1ColourValue.html" title="Class representing colour.">ColourValue</a>&amp; colour = <a class="code" href="classOgre_1_1ColourValue.html#a8eba66b2908f44f00f8d9c9ec25877de">ColourValue::White</a>);
<a name="l00098"></a>00098 
<a name="l00103"></a><a class="code" href="classOgre_1_1Billboard.html#a21d65daa1be659c9234da380b8e9f2f4">00103</a>         <span class="keyword">const</span> <a class="code" href="classOgre_1_1Radian.html" title="Wrapper class which indicates a given angle value is in Radians.">Radian</a>&amp; <a class="code" href="classOgre_1_1Billboard.html#a21d65daa1be659c9234da380b8e9f2f4" title="Get the rotation of the billboard.">getRotation</a>(<span class="keywordtype">void</span>)<span class="keyword"> const </span>{ <span class="keywordflow">return</span> mRotation; }
<a name="l00104"></a>00104 
<a name="l00109"></a>00109         <span class="keywordtype">void</span> setRotation(<span class="keyword">const</span> <a class="code" href="classOgre_1_1Radian.html" title="Wrapper class which indicates a given angle value is in Radians.">Radian</a>&amp; rotation);
<a name="l00110"></a>00110 
<a name="l00116"></a>00116         <span class="keywordtype">void</span> setPosition(<span class="keyword">const</span> <a class="code" href="classOgre_1_1Vector3.html" title="Standard 3-dimensional vector.">Vector3</a>&amp; position);
<a name="l00117"></a>00117 
<a name="l00123"></a>00123         <span class="keywordtype">void</span> setPosition(<a class="code" href="namespaceOgre.html#aa3a7b6dfb905e6572d62f0dfa3d4274d" title="Software floating point type.">Real</a> x, <a class="code" href="namespaceOgre.html#aa3a7b6dfb905e6572d62f0dfa3d4274d" title="Software floating point type.">Real</a> y, <a class="code" href="namespaceOgre.html#aa3a7b6dfb905e6572d62f0dfa3d4274d" title="Software floating point type.">Real</a> z);
<a name="l00124"></a>00124 
<a name="l00130"></a>00130         <span class="keyword">const</span> <a class="code" href="classOgre_1_1Vector3.html" title="Standard 3-dimensional vector.">Vector3</a>&amp; getPosition(<span class="keywordtype">void</span>) <span class="keyword">const</span>;
<a name="l00131"></a>00131 
<a name="l00139"></a>00139         <span class="keywordtype">void</span> setDimensions(<a class="code" href="namespaceOgre.html#aa3a7b6dfb905e6572d62f0dfa3d4274d" title="Software floating point type.">Real</a> width, <a class="code" href="namespaceOgre.html#aa3a7b6dfb905e6572d62f0dfa3d4274d" title="Software floating point type.">Real</a> height);
<a name="l00140"></a>00140 
<a name="l00142"></a><a class="code" href="classOgre_1_1Billboard.html#ae5bf31f1d013a1f0c3b5a92e46c76d11">00142</a>         <span class="keywordtype">void</span> <a class="code" href="classOgre_1_1Billboard.html#ae5bf31f1d013a1f0c3b5a92e46c76d11" title="Resets this Billboard to use the parent BillboardSet&#39;s dimensions instead of it&#39;s own...">resetDimensions</a>(<span class="keywordtype">void</span>) { mOwnDimensions = <span class="keyword">false</span>; }
<a name="l00149"></a>00149         <span class="keywordtype">void</span> setColour(<span class="keyword">const</span> <a class="code" href="classOgre_1_1ColourValue.html" title="Class representing colour.">ColourValue</a>&amp; colour);
<a name="l00150"></a>00150 
<a name="l00153"></a>00153         <span class="keyword">const</span> <a class="code" href="classOgre_1_1ColourValue.html" title="Class representing colour.">ColourValue</a>&amp; getColour(<span class="keywordtype">void</span>) <span class="keyword">const</span>;
<a name="l00154"></a>00154 
<a name="l00160"></a>00160         <span class="keywordtype">bool</span> hasOwnDimensions(<span class="keywordtype">void</span>) <span class="keyword">const</span>;
<a name="l00161"></a>00161 
<a name="l00163"></a>00163         <a class="code" href="namespaceOgre.html#aa3a7b6dfb905e6572d62f0dfa3d4274d" title="Software floating point type.">Real</a> getOwnWidth(<span class="keywordtype">void</span>) <span class="keyword">const</span>;
<a name="l00164"></a>00164 
<a name="l00166"></a>00166         <a class="code" href="namespaceOgre.html#aa3a7b6dfb905e6572d62f0dfa3d4274d" title="Software floating point type.">Real</a> getOwnHeight(<span class="keywordtype">void</span>) <span class="keyword">const</span>;
<a name="l00167"></a>00167 
<a name="l00170"></a>00170         <span class="keywordtype">void</span> _notifyOwner(<a class="code" href="classOgre_1_1BillboardSet.html" title="A collection of billboards (faces which are always facing the given direction) with the same (default...">BillboardSet</a>* owner);
<a name="l00171"></a>00171 
<a name="l00181"></a><a class="code" href="classOgre_1_1Billboard.html#aeea6556e787c984b97bf779b7b90dbb1">00181</a>         <span class="keywordtype">bool</span> <a class="code" href="classOgre_1_1Billboard.html#aeea6556e787c984b97bf779b7b90dbb1" title="Returns true if this billboard use individual texture coordinate rect (i.e.">isUseTexcoordRect</a>(<span class="keywordtype">void</span>)<span class="keyword"> const </span>{ <span class="keywordflow">return</span> mUseTexcoordRect; }
<a name="l00182"></a>00182 
<a name="l00190"></a>00190         <span class="keywordtype">void</span> setTexcoordIndex(<a class="code" href="namespaceOgre.html#aa8263b218e7d187ad5ef03a73a6ad7fd">uint16</a> texcoordIndex);
<a name="l00191"></a>00191 
<a name="l00197"></a><a class="code" href="classOgre_1_1Billboard.html#a44c9c4056e597a7b50d8881fc1d1785d">00197</a>         <a class="code" href="namespaceOgre.html#aa8263b218e7d187ad5ef03a73a6ad7fd">uint16</a> <a class="code" href="classOgre_1_1Billboard.html#a44c9c4056e597a7b50d8881fc1d1785d" title="getTexcoordIndex() returns the previous value set by setTexcoordIndex().">getTexcoordIndex</a>(<span class="keywordtype">void</span>)<span class="keyword"> const </span>{ <span class="keywordflow">return</span> mTexcoordIndex; }
<a name="l00198"></a>00198 
<a name="l00204"></a>00204         <span class="keywordtype">void</span> setTexcoordRect(<span class="keyword">const</span> <a class="code" href="structOgre_1_1TRect.html">FloatRect</a>&amp; texcoordRect);
<a name="l00205"></a>00205 
<a name="l00211"></a>00211         <span class="keywordtype">void</span> setTexcoordRect(<a class="code" href="namespaceOgre.html#aa3a7b6dfb905e6572d62f0dfa3d4274d" title="Software floating point type.">Real</a> u0, <a class="code" href="namespaceOgre.html#aa3a7b6dfb905e6572d62f0dfa3d4274d" title="Software floating point type.">Real</a> v0, <a class="code" href="namespaceOgre.html#aa3a7b6dfb905e6572d62f0dfa3d4274d" title="Software floating point type.">Real</a> u1, <a class="code" href="namespaceOgre.html#aa3a7b6dfb905e6572d62f0dfa3d4274d" title="Software floating point type.">Real</a> v1);
<a name="l00212"></a>00212 
<a name="l00217"></a><a class="code" href="classOgre_1_1Billboard.html#a520cbeb132a68eeb38f34e87e71f2749">00217</a>         <span class="keyword">const</span> <a class="code" href="structOgre_1_1TRect.html">FloatRect</a>&amp; <a class="code" href="classOgre_1_1Billboard.html#a520cbeb132a68eeb38f34e87e71f2749" title="getTexcoordRect() returns the previous value set by setTexcoordRect().">getTexcoordRect</a>(<span class="keywordtype">void</span>)<span class="keyword"> const </span>{ <span class="keywordflow">return</span> mTexcoordRect; }
<a name="l00218"></a>00218     };
<a name="l00219"></a>00219 
<a name="l00223"></a>00223 }
<a name="l00224"></a>00224 
<a name="l00225"></a>00225 <span class="preprocessor">#endif</span>
</pre></div></div><!-- contents -->
<hr>
<p>
Copyright &copy; 2012 Torus Knot Software Ltd<br />
<!--Creative Commons License--><a rel="license" href="http://creativecommons.org/licenses/by-sa/3.0/"><img alt="Creative Commons License" style="border-width:0" src="http://i.creativecommons.org/l/by-sa/3.0/88x31.png" /></a><br />This work is licensed under a <a rel="license" href="http://creativecommons.org/licenses/by-sa/3.0/">Creative Commons Attribution-ShareAlike 3.0 Unported License</a>.<br/>
		<!--/Creative Commons License--><!-- <rdf:RDF xmlns="http://web.resource.org/cc/" xmlns:dc="http://purl.org/dc/elements/1.1/" xmlns:rdf="http://www.w3.org/1999/02/22-rdf-syntax-ns#">
		<Work rdf:about="">
			<license rdf:resource="http://creativecommons.org/licenses/by-sa/2.5/" />
	<dc:type rdf:resource="http://purl.org/dc/dcmitype/Text" />
		</Work>
		<License rdf:about="http://creativecommons.org/licenses/by-sa/2.5/"><permits rdf:resource="http://web.resource.org/cc/Reproduction"/><permits rdf:resource="http://web.resource.org/cc/Distribution"/><requires rdf:resource="http://web.resource.org/cc/Notice"/><requires rdf:resource="http://web.resource.org/cc/Attribution"/><permits rdf:resource="http://web.resource.org/cc/DerivativeWorks"/><requires rdf:resource="http://web.resource.org/cc/ShareAlike"/></License></rdf:RDF> -->

Last modified Fri May 25 2012 21:48:49
</p>
</body>
</html>
